-----------------------
-- Gimmicks by BetaM --
-----------------------

if gm==nil then 
	gm={} 
else 
	error("Table gm already taken! Shutting down Gimmicks.")
	return 1
end
if tonumber(game("sv_gamemode"))~=0 and tonumber(game("sv_gamemode"))~=3 then
	error("Incompatible game mode. Shutting down Gimmicks.")
	return 1
end

-- Options:
gm.disappear=0 -- 1 - on; 0 - off
gm.rotate=0    -- 1 - on; 0 - off
gm.hud_y=397   -- Default is 397
gm.hud_id=33   -- Default is 33
gm.fungimmicks=1 -- 1 - on; 0 - off
gm.mingimmicks=1 -- Minimal number of gimmicks per round, max. is 8

math.randomseed(os.time())
gm.color="175175175"
gm.text="______________________________________________________________________________________________________"
gm.gimmicks={"speed","flash","health","slowdown","doubledamage","halfdamage"}
gm.fungim={"block","snark","teleport","nokill"}
if gm.fungimmicks==1 then
	for t=1,#gm.fungim do
		table.insert(gm.gimmicks,gm.fungim[t])
	end
end
gm.gim={}
gm.length=0
gm.gback={}
gm.gid={}
gm.solidmaxgimmicks=8
gm.counter=0

addhook("startround","gm.start")
function gm.start(m)
	if #player(0,"tableliving")>0 then
		gm.gid={}
		gm.gim={}
		gm.gback={}
		gm.length=tonumber(game("mp_roundtime"))
		parse("hudtxt "..gm.hud_id.." \""..gm.color..gm.text.."\" 320 "..gm.hud_y.." 1")
		gm.maxgimmicks=(((gm.length*60)-20)/10)
		if gm.maxgimmicks>gm.solidmaxgimmicks then
			gm.maxgimmicks=gm.solidmaxgimmicks
		end
		if gm.length==2 and gm.maxgimmicks>=8 then
			gm.maxgimmicks=7
		end
		local ran=math.random(gm.mingimmicks,gm.maxgimmicks)
		local r=0
		local t={}
		local d=1
		local range=gm.length*5
		if ran>1 then
			msg(gm.color.."There will be "..ran.." gimmicks in this round.")
		else
			msg(gm.color.."There will be 1 gimmick in this round.")
		end
		for i=1,ran do
			r=math.random(10,(gm.length*60)-10)
			if #t>0 then
				d=1
				while (d<=#t) do
					if r>=t[d]-range and r<=t[d]+range then
						if math.random(1,2)==1 then
							if t[d]-range<10 then
								r=math.random(t[d]+range,(gm.length*60)-10)
							else
								r=math.random(10,t[d]-range)
							end
						else
							if t[d]+range>(gm.length*60)-10 then
								r=math.random(10,t[d]-range)
							else
								r=math.random(t[d]+range,(gm.length*60)-10)
							end
						end
						d=1
					else
						d=d+1
					end
				end
			end
			table.insert(t,r)
			table.insert(gm.gim,math.random(1,#gm.gimmicks))
			table.insert(gm.gid,image("gfx/hud/gim_"..gm.gimmicks[gm.gim[#gm.gim]]..".png",640*(r/(gm.length*60)),gm.hud_y-7,2))
			table.insert(gm.gback,image("gfx/hud/gim_back.png",640*(r/(gm.length*60)),gm.hud_y-3,2))
			imagescale(gm.gback[#gm.gback],2,2)
			imagealpha(gm.gid[#gm.gid],0)
			imagealpha(gm.gback[#gm.gback],0)
			imagecolor(gm.gid[#gm.gid],175,175,175)
			tween_alpha(gm.gid[#gm.gid],2000,1)
			tween_alpha(gm.gback[#gm.gback],2000,1)
			timer(r*1000,"gm.gimmick_"..gm.gimmicks[gm.gim[#gm.gim]].."")
			if gm.disappear==1 then
				timer(r*1000,"gm.gimmick_go",""..#gm.gid.."")
			end
		end
		gm.counter=image("gfx/hud/gim_cursor.png",0,gm.hud_y+15,2)
		imagescale(gm.counter,1.5,1.5)
		tween_move(gm.counter,gm.length*60000,640,gm.hud_y+15)
	end
end

addhook("endround","gm.endround")
function gm.endround()
	for i=1,#gm.gimmicks do
		freetimer("gm.gimmick_"..gm.gimmicks[i].."")
		freetimer("gm.gimmick_go",""..i.."")
	end
	tween_move(gm.counter,5000,0,gm.hud_y+15)
	if gm.rotate==1 then
		tween_rotateconstantly(gm.counter,-10)
	end
	for d=1,#gm.gid do
		tween_alpha(gm.gid[d],5000,0)
	end
	for c=1,#gm.gback do
		tween_alpha(gm.gback[c],5000,0)
	end
end

function gm.gimmick_go(i)
	local id=tonumber(i)
	tween_alpha(gm.gid[id],1000,0)
	tween_alpha(gm.gback[id],1000,0)
end
function gm.gimmick_speed()
	local id=0
	msg(gm.color.."Speed gimmick started! Everyone is running really fast for a few seconds!")
	local s=math.random(5,10)*10
	local ps=0
	for p=1,#player(0,"tableliving") do
		id=player(0,"tableliving")[p]
		ps=player(id,"speedmod")
		parse("speedmod "..id.." "..s.."")
		timer(5000,"parse","speedmod "..id.." "..ps.."")
	end
end
function gm.gimmick_slowdown()
	local id=0
	msg(gm.color.."Slowdown gimmick is on! Everyone is really slow for a short time!")
	local s=-math.random(10,30)
	local ps=0
	for p=1,#player(0,"tableliving") do
		id=player(0,"tableliving")[p]
		ps=player(id,"speedmod")
		parse("speedmod "..id.." "..s.."")
		timer(5000,"parse","speedmod "..id.." "..ps.."")
	end
end
function gm.gimmick_teleport()
	local id=0
	local pl=0
	msg(gm.color.."Teleport gimmick initiated! Everyone is swapping place with everybody!")
	local s=math.random(5,10)*10
	t=player(0,"tableliving")
	for p=1,#player(0,"tableliving") do
		id=player(0,"tableliving")[p]
		for c=1,#t do
			if t[i]==id then
				table.remove(t,i)
			end
		end
		if #t==0 then
			break
		end
		pl=t[math.random(1,#t)]
		for i=1,#t do
			if t[i]==pl then
				table.remove(t,i)
			end
		end
		local x=player(id,"x")
		local y=player(id,"y")
		parse("setpos "..id.." "..player(pl,"x").." "..player(pl,"y").."")
		parse("setpos "..pl.." "..x.." "..y.."")
	end
end
function gm.gimmick_flash()
	msg(gm.color.."Flash gimmick deployed! Everyone is stunned for a few seconds!")
	parse("sv_sound \"weapons/g_flash.wav\"")
	parse("flashplayer 0 "..math.random(50,100).."")
end
function gm.gimmick_health()
	msg(gm.color.."Health gimmick activated! Everyone's health is regenerating for a few moments!")
	local r=math.random(2,7)
	local id=0
	for p=1,#player(0,"tableliving") do
		id=player(0,"tableliving")[p]
		timer(100,"gm.hpregen",""..id.."",r*10)
	end
end
function gm.gimmick_doubledamage()
	msg(gm.color.."Double damage gimmick time! Everyone's damage is doubled for a short while!")
	parse("mp_damagefactor 2")
	timer(5000,"parse","mp_damagefactor 1")
end
function gm.gimmick_halfdamage()
	msg(gm.color.."Half damage gimmick triggered! Everyone's damage is halved for a moment!")
	parse("mp_damagefactor 0.5")
	timer(5000,"parse","mp_damagefactor 1")
end

function gm.gimmick_block()
	msg(gm.color.."Suddenly, block gimmick! Everyone is stuck inside a wall!")
	local id=0
	for p=1,#player(0,"tableliving") do
		id=player(0,"tableliving")[p]
		parse("spawnobject 1 "..player(id,"tilex").." "..player(id,"tiley").." 0 0 0 0")
		parse("setpos "..id.." "..(player(id,"tilex")*32+16).." "..(player(id,"tiley")*32+16).."")
	end
end
function gm.gimmick_snark()
	msg(gm.color.."Watch out, the snark gimmick is on! Everyone gets attacked by snarks!")
	local id=0
	for p=1,#player(0,"tableliving") do
		id=player(0,"tableliving")[p]
		parse("spawnnpc 3 "..(player(id,"tilex")+1).." "..player(id,"tiley").." -90")
		parse("spawnnpc 3 "..(player(id,"tilex")-1).." "..player(id,"tiley").." 90")
		parse("spawnnpc 3 "..player(id,"tilex").." "..(player(id,"tiley")-1).." 180")
		parse("spawnnpc 3 "..player(id,"tilex").." "..(player(id,"tiley")+1).." 0")
	end
end
function gm.gimmick_nokill()
	msg(gm.color.."Rejoice, the star gimmick has been initiated! Everyone is invincible for a short time!")
	parse("mp_damagefactor 0")
	timer(5000,"parse","mp_damagefactor 1")
end

function gm.hpregen(i)
	local id=tonumber(i)
	parse("sethealth "..id.." "..player(id,"health")+1)
end

addhook("die","gm.die")
addhook("leave","gm.die")
function gm.die(id)
	freetimer("gm.hpregen",""..id.."")
end